#!/usr/bin/env python
# -*- coding:utf-8 -*-
import numpy as np


def butterworth(img, d, n):
    f = np.fft.fft2(img)
    fshift = np.fft.fftshift(f)

    mask = np.zeros(img.shape)
    center = tuple(map(lambda x: (x - 1) / 2, img.shape))
    for i in range(mask.shape[0]):
        for j in range(mask.shape[1]):
            def cal_distance(pa, pb):
                from math import sqrt
                return sqrt((pa[0] - pb[0]) ** 2 + (pa[1] - pb[1]) ** 2)

            dis = cal_distance(center, (i, j))
            mask[i, j] = 1 - 1 / ((1 + (d / dis)) ** n)
            if dis < 1:
                mask[i, j] = 1
    # mask[100,:] = 0
    new_img = np.abs(np.fft.ifft2(np.fft.ifftshift(fshift * mask)))
    return new_img.astype(np.uint8)


def fft_mask(img, d):
    f = np.fft.fft2(img)
    fshift = np.fft.fftshift(f)

    mask = np.zeros(img.shape)
    center = tuple(map(lambda x: (x - 1) / 2, img.shape))
    for i in range(mask.shape[0]):
        for j in range(mask.shape[1]):
            def cal_distance(pa, pb):
                from math import sqrt
                return sqrt((pa[0] - pb[0]) ** 2 + (pa[1] - pb[1]) ** 2)

            dis = cal_distance(center, (i, j))
            mask[i, j] = 0 if dis > d else 1
    new_img = np.abs(np.fft.ifft2(np.fft.ifftshift(fshift * mask))).astype(np.uint8)
    return new_img
