#!/usr/bin/env python
# -*- coding:utf-8 -*-
from sklearn.cluster import KMeans
from util import *
from filters import butterworth,fft_mask


def kmeans(pair, cluster_num = 5,filter='butter'):
    img_list = pre(pair,'clahe',filter)
    denoise = img_list['denoise']

    km = KMeans(n_clusters = cluster_num)
    feature = [[denoise[k, j]] for k in range(200) for j in range(200)]
    ll = km.fit_predict(feature)
    mask = [np.array([x for x in map(lambda x: 255 if x == i else 0, ll)]).reshape([200, 200]) for i in
            range(cluster_num)]
    edge = select_mask(img_list['ori'], mask).astype(np.uint8)
    return edge


def kmeans_back(pair, edge):
    img_list = pre(pair, 'clahe', filter)

    kernel = cv.getStructuringElement(cv.MORPH_ELLIPSE, (3, 3))
    close = cv.morphologyEx(edge, cv.MORPH_CLOSE, kernel, iterations = 5)
    img_list['close'] = close
    save_img(img_list, pair[0], pair[1][:-4])
    calcRes(img_list['ori'], img_list['close'], pair[0], pair[1][:-4])


def select_mask(ori_img, mask_list):
    num = len(mask_list) + 1
    plt.figure(figsize = (100, 20))
    plt.title('ori_img')
    plt.subplot(1, num, 1)
    plt.imshow(ori_img, 'gray')
    for i, mask in enumerate(mask_list):
        plt.subplot(1, num, i + 2)
        plt.title('mask ' + str(i))
        plt.imshow(mask, 'gray')
    plt.show()
    i = input('Which mask fits the signal best (int): ')
    plt.close()
    return mask_list[int(i)]
